/*

BSD 3-Clause License

Copyright (c) 2015-2022, SwissMicros
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


  The software and related material is released as “NOMAS”  (NOt MAnufacturer Supported).

  1. Info is released to assist customers using, exploring and extending the product
  2. Do NOT contact the manufacturer with questions, seeking support, etc. regarding
     NOMAS material as no support is implied or committed-to by the Manufacturer
  3. The Manufacturer may reply and/or update materials if and when needed solely
     at their discretion

*/
#ifndef __NUM_H__
#define __NUM_H__

/*
 ▄▄   ▄
 █▀▄  █ ▄   ▄  ▄▄▄▄▄
 █ █▄ █ █   █  █ █ █
 █  █ █ █   █  █ █ █
 █   ██ ▀▄▄▀█  █ █ █

*/


#include <bid_conf.h>
#include <bid_functions.h>

typedef BID_UINT128 num_t;

#define NUM_MAX_MANTISSA_DIGITS 34

#define num_to_string     bid128_to_string
#define num_from_int32    bid128_from_int32

#define num_to_string     bid128_to_string
#define num_from_string   bid128_from_string

#define num_to_int        bid128_to_int32_int

#define num_add           bid128_add
#define num_sub           bid128_sub
#define num_mul           bid128_mul
#define num_div           bid128_div

#define num_abs           bid128_abs
#define num_pow           bid128_pow
#define num_exp           bid128_exp
#define num_exp10         bid128_exp10
#define num_sqrt          bid128_sqrt
#define num_log           bid128_log
#define num_log10         bid128_log10
#define num_sin           bid128_sin
#define num_cos           bid128_cos
#define num_tan           bid128_tan
#define num_asin          bid128_asin
#define num_acos          bid128_acos
#define num_atan          bid128_atan

#define num_gt            bid128_quiet_greater
#define num_eq            bid128_quiet_equal
#define num_lt            bid128_quiet_less
#define num_le            bid128_quiet_less_equal
#define num_ne            bid128_quiet_not_equal
#define num_ge            bid128_quiet_greater_equal

#endif
